#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use PureMessage::Manager::Request qw($REQUEST);
use PureMessage::Manager::Policy;
use PureMessage::Manager::Utils qw(html_escape);
use PureMessage::Manager::Widget::ThemeSectionHeader;
use PureMessage::Manager::Widget::ThemeSectionFooter;

my $id = $REQUEST->query('id');
my $p = PureMessage::Manager::Policy->new();
my ($cmd_name, %cmds, $is_test);


if ($cmd_name = $REQUEST->query('action')) { 
    foreach ($p->action_list) {
        $cmds{$_->name} = $_;
    }
}
elsif ($cmd_name = $REQUEST->query('test')) {
    $is_test = 1;
    foreach ($p->test_list) {
        $cmds{$_->name} = $_;
    }
}

my $cmd = $cmds{$cmd_name};
my $title = $cmd->label;
my $hdr = PureMessage::Manager::Widget::ThemeSectionHeader->new(width=>350, title=>$title)->output;
my $tb = "";
my %btns = ("Ok"=>"populate();", "Cancel"=>"window.close();", "Revert"=>"load_values();");
while ( my ($label, $action) = each %btns ) {
    $tb .= <<EOT;
    <td class="tableContent">
        <table border="0" cellpadding="1" cellspacing="0" width="100%">
        <tr>
            <td class="tableButtonOutline">
                <table border="0" cellpadding="3" cellspacing="0">
                <tr>
                    <td class="tableButton"><a href="javascript:void()" onClick="$action">$label</a></td>
                </tr>
                </table>
            </td>
        </tr>
        </table>
    </td>
EOT
}

$tb = <<EOT;
<table border="0" cellpadding="1" cellspacing="0"><tr>$tb</tr></table>
EOT


my $ftr = PureMessage::Manager::Widget::ThemeSectionFooter->new(toolbar=>$tb)->output;
my $html = "";

for(my $i=0; $i < $cmd->args; $i++) {
    my $name = $cmd->arg_name($i);
    $html .= "<tr>";
    my $label = ($cmd->arg_label($i) || ucfirst(lc($name)));
    $label = html_escape($label);
    if ($cmd->arg_type($i) eq 'select') {
        # build a select box
        $html .= "<td class='tableRow' width=1></td><td class='tableRow' nowrap=nowrap>$label</td>\n<td class='tableRow'>";
        $html .= "<select id='arg_$i' name='$name' class=stretch>\n";
        my $opts = $cmd->arg_options($i);
        foreach ( sort keys %$opts ) {
            unless (!$is_test && /_not$/) {
                $html .= "<option value='$_'>$opts->{$_}\n"; 
            }
        }
        $html .= "</select></td>\n";
    }
    elsif ($cmd->arg_type($i) =~ /^checkbox/) {
        if ($cmd->arg_type($i) =~ /^checkbox_(.*)$/) {
            my $type = $1;
            # build a checkbox      
            $html .= "<td class='tableRow' width=1><input id='xarg_$i' name='$name' type=checkbox></td><td class='tableRow' nowrap=nowrap>$label</td>";
            # build a text field
            $html .= "<td class='tableRow'><input id='arg_$i' name='$name' class=stretch></td>";
        }
        else {
            # build a checkbox      
            $html .= "<td class='tableRow' width=1><input id='xarg_$i' name='$name' type=checkbox></td><td class='tableRow' nowrap=nowrap colspan=2>$label</td>";
        }
    }       
    else {
        # build a regular text field
        $html .= "<td class='tableRow' width=1></td><td class='tableRow' nowrap=nowrap>$label</td>\n";
        $html .= "<td class='tableRow' width='100%'><input class='tableRow' id='arg_$i' name='$name' class=stretch></td>";
    }
    $html .= "</tr>";
}

my $argname = $is_test ? "arg" : "a_arg";
my $cmdtype = $is_test ? "Test" : "Action";

print <<EOT;
Content-Type: text/html

<!doctype html public "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>Specify $cmdtype Arguments...</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="stylesheet" href="/puremessage.css">
<SCRIPT language="JavaScript" src='/javascript.cgi'></SCRIPT>
<SCRIPT language="JavaScript">
<!--
function load_values() {
    for ( i=0; i < 10; i++) {
        arg = window.opener.document.getElementById('$argname'+i+'_$id');
        my_arg = document.getElementById('arg_'+i);
        my_xarg = document.getElementById('xarg_'+i);
        if (arg) {
            if (my_xarg) {
                if ( my_arg ) {
                    if ( my_arg.options ) {
                        var j=0;
                        for(j=0; j<my_arg.options.length; j++) {
                            if ( my_arg.options[i].value == arg.value ) {
                                my_arg.selectedIndex = i;
                            }
                        }
                    }
                    else {
                        my_arg.value = arg.value;
                    }
                    if (my_arg.value.length) { 
                        my_xarg.checked = 1; 
                    }
                }
                else {
                    if (arg.value != 0) {
                        my_xarg.checked = 1
                    }
                    else {
                        my_xarg.checked = 0
                    }
                }
            }
            else if (my_arg) {
                if ( my_arg.options ) {
                    var j=0;
                    for(j=0; j<my_arg.options.length; j++) {
                        if ( my_arg.options[j].value == arg.value ) {
                            my_arg.selectedIndex = j;
                        }
                    }
                }
                else {
                    my_arg.value = arg.value;
                }
            }
        }
    }
}

function populate() {
    for ( i=0; i < 10; i++) {
        arg = window.opener.document.getElementById('$argname'+i+'_$id');
        if (arg) {
            my_arg = document.getElementById('arg_'+i);
            my_xarg = document.getElementById('xarg_'+i);
            if (my_xarg != null) {
                if (my_xarg.checked) {
                    if (my_arg) {
                        if (my_arg.options) {
                            arg.value = my_arg.options[my_arg.selectedIndex].value;
                        }
                        else {
                            arg.value = my_arg.value;
                        }
                    }
                    else {
                        arg.value = 1;
                    }
                }
                else {
                    if (my_arg) {
                        arg.value = "";
                    }
                    else {
                        arg.value = 0;
                    }
                }
            }
            else if (my_arg) {
                if (my_arg.options) {
                    arg.value = my_arg.options[my_arg.selectedIndex].value;
                }
                else {
                    arg.value = my_arg.value;
                }
            }
            else {
            }
        }
    }
    window.close();
}

//-->
</SCRIPT>
</head>

<body onLoad="load_values();">
$hdr
<table width="100%" cellspacing=0 cellpadding=4>
$html
</table>
$ftr
</body>
EOT

