#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Policy;
use PureMessage::Version qw($PREFIX);
use PureMessage::Resources::Manager;

my %vars;
our %text;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Policy',
                                'stderr_to_stdout' =>1
                              );



my $list_id = $in{'id'};
# see if we have list specific help

if ($list_id =~ m/^[a-zA-Z\-]+$/ and -e "$PREFIX/html/mgr/mgr_pol_list_$list_id.html") {
  $r->add_help(text => "Help", tab => "pol", page => "mgr/mgr_pol_list_$list_id" );
}
else {
  # default to the generic edit list help
  $r->add_help(text => "Help", tab => "pol", page => "mgr_pol_edit_list" );
}

my $data;

($data) = PureMessage::List->Available($list_id) if $list_id;
my $source = $data->{source};

my $is_resource = 0;

eval {
   
   # determine if this is a resource item or not
   my $rm = PureMessage::Resources::Manager->new();
   my $res = $rm->find($list_id);
   $is_resource = 1 if $res;
};


if($list_id and $data and ($source !~ /^ldap:/)) {
    $r->title("Edit List : $data->{name}");
    unless ($is_resource) {
        eval {
            require PureMessage::Manager::Response::ServerGroups::Publications;
            if ($source =~ s/^file://) {
                $source =~ s/^$PREFIX\/*//;
                $r->print(PureMessage::Manager::Response::ServerGroups::Publications::Publish($source, $data->{name}, 'obj_type'=>"list"));
            }
        };
    }
    my $new_widget = $r->addListEditor(
                                       name => 'edit_list',
                                       list => $list_id,
                                       page => 0,
                                       action => $ENV{SCRIPT_NAME},
                                       state => { id => $list_id},
                                      );   
    #$new_widget->read_input($REQUEST);
} elsif ($source =~ /^ldap:/) {
    $r->raise_error(<<"EOT");
LDAP Lists cannot be edited directly.<BR/>
<A HREF="lists.cgi?edit=$list_id">Click here</A> to modify the list parameters.
EOT
} else {
    $r->title('Edit List');
    $r->raise_error('Invalid List Name') unless $list_id;
    $r->error_dlg();
}
            
$r->send();
