#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Policy;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Widget::ListEditor;
use PureMessage::Map;
use PureMessage::Version qw($PREFIX);
use PureMessage::Resources::Manager;

my %vars;
our %text;

my $WIDGET = new PureMessage::Manager::Widget;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Policy',
                                'stderr_to_stdout' =>1
                              );



my $map_id = $in{'id'};

# see if we have map specific help
if ($map_id =~ m/^[a-zA-Z\-]+$/ and -e "$PREFIX/html/mgr/mgr_pol_map_$map_id.html") {
  $r->add_help(text => "Help", tab => "pol", page => "mgr/mgr_pol_map_$map_id" );
}
else {
  # default to the generic edit map help
  $r->add_help(text => "Help", tab => "pol", page => "mgr_pol_edit_map" );
}


my $data;

($data) = PureMessage::Map->Available($map_id) if $map_id;
my $source = $data->{source};
my $is_resource = 0;

eval {
   
   # determine if this is a resource item or not
   my $rm = PureMessage::Resources::Manager->new();
   my $res = $rm->find($map_id);
   $is_resource = 1 if $res;
};


if(($map_id and $data) and $source !~ m/^ldap:/) {
    $r->title("Edit Map : $data->{name}");
    unless ($is_resource) {
        eval {
            require PureMessage::Manager::Response::ServerGroups::Publications;
            my $source = $data->{source};
            if ($source =~ s/^file://) {
                $source =~ s/^$PREFIX\/*//;
                $r->print(PureMessage::Manager::Response::ServerGroups::Publications::Publish($source, $data->{name}, 'obj_type'=>"map"));
            }
        };
    }
    my $new_widget = $WIDGET->widget(CLASS => 'PureMessage::Manager::Widget::MapEditor',
                                   name => 'edit_map',
                                   list => $map_id,
                                   page => 0,
                                   action => $ENV{SCRIPT_NAME},
                                   state => { id => $map_id},
                             );   
    $r->add_part($new_widget,'edit_map_body');
    if($new_widget->read_input($REQUEST)) {}
} elsif($source =~ m/^ldap:/) {
    $r->raise_error(<<"EOT");
LDAP Maps cannot be edited directly.<BR/>
<A HREF="lists.cgi?show_only=map&edit=$map_id">Click here</A> to modify the map parameters.
EOT
} else {
    $r->title('Edit Map');
    $r->raise_error('Invalid Map Name') unless $map_id;
    $r->error_dlg();
}

            

$r->send();
