#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use HTML::Template;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Config qw(%config);
use PureMessage::Manager::Response::Policy::Repository;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Widget::Grid;
use PureMessage::Manager::Widget::Form;
use PureMessage::Manager::Widget::PaneBox;
use PureMessage::Manager::Widget::Template;
use PureMessage::Manager::Lang;

my %vars;
my $WIDGET = new PureMessage::Manager::Widget;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Policy::Repository',
                                'stderr_to_stdout' =>1
                              );
my $dir = "$config{prefix}/etc/manager/repository/";

my @files;

my $script = $in{f} || "$config{prefix}/etc/policy.siv";

my $data = $r->prepareFile($script);

my $options;

#use Data::Dumper;
#print "<PRE> ";
#print Dumper($data->{vars});
#print "</PRE>";

my %form_data;

my @fields;

my $form = $WIDGET->widget(CLASS => 'PureMessage::Manager::Widget::Form',
                        name => "form_data",
                        data => \%form_data,
                        columns => 2,
                        fields =>\@fields,
                        title => "Repository View",
                        action => 'examine.cgi',
                        width=>"75%",
                        keys => sub { return ucfirst(shift)},
                       );                        


if ($in{use}) {
    my @v = grep { /^v\d+$/ } keys %in;
    foreach my $fixup (@v) {
        $fixup =~ /^v(\d+)$/;
        $data->{vars}->[$1]->{value} = $in{$fixup};
    }
    
    my @lines = $r->fixupfile($data);
    $r->save_source(join('',@lines));
    $r->add_part($r->show_source(),'show_source');
  
} else {
    if ($data) {
        $form_data{'Description'} = join('<BR>',@{$data->{desc}}) || "No description for this file";
        $form_data{'FileName'} = $data->{file};
        $form_data{'Location'} = $data->{path};
        $r->add_part($form,'form_data');
        @fields = qw( FileName Location Description );
        $options = "<table>";
        my $index = 0;
        foreach my $v (@{$data->{vars}}) {
          my @o = @{$v->{desc}};
          $o[0] = "<b>$o[0]</b>" if $o[0];
          $options .= "<tr><td>";
          $options .= join('<BR>',@o);
          $options .= "</td></tr>";
          $options .= "<tr><td>";
          if ($v->{valid}) {
                $options .= "<input type=text name=v$index class=stretch value='$v->{value}'>";
          } else {
                $options .= "<i>This script has been modified from it's original form and this setting cannot be";
                $options .= "modified further by this script.</i>";
          }
          $options .= "</td></tr>";
          $index++;
        }
        $options .= "</table>";
       
    } else {
      $options = "Unable to collect Script Data";
    }


    my $tb = $WIDGET->widget('CLASS' => 'PureMessage::Manager::Widget::ToolBar',
                              name=>'tb',
                              state => { f=> $script },
                              buttons => [[ { type=>'image',name=>'use',icon=>'ok',text=>'Use' },
                                            { type=>'image',name=>'cancel',icon=>'cancel',text=>'Cancel' },
                                         ]],
                             );

    $r->add_part('<form name="examine.cgi">');
    $r->add_part($WIDGET->widget( CLASS=>'PureMessage::Manager::Widget::PaneBox',
                                  content=>$options,
                                  width=>"75%",
                                  title=>'Options',
                                  toolbar=>$tb,
                                ),'script_options');

    $r->add_part('</form>');
}

$r->title('Examine Policy Script');
$r->send();



