#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Response::Policy;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Lang;
use PureMessage::Map;
use PureMessage::List;
use PureMessage::Resources::Manager;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Policy',
                                'stderr_to_stdout' => 1,
                              );
$r->add_help(text => "Help", tab => "pol", page => "mgr_pol_test_lists_maps");

my $rm = PureMessage::Resources::Manager->new();

###############################################################################
# Set default replacement vars for the template.
###############################################################################
my %vars;
map { $vars{$_} = $in{$_} } keys %in;

###############################################################################
# Test the list/map...
###############################################################################
eval {
    # If we were given a list to test, test it.
    if ($in{list_id}) {
        my $val = $in{list_value};
        if ($val) {
            my $list;
            if(my $temp = $rm->find($in{list_id})) {
                $list = $temp->native;
            } else {
                $list = PureMessage::List->new( $in{list_id} );
            }            
            my $match = $list->matcher()->($val);
            $vars{list_results} = $match ? text('test_list_match') : text('test_list_no_match');
        }
    }

    # If we were given a map to test, test it.
    if ($in{map_id}) {
        my $val = $in{map_value};
        if ($val) {
            my $map;
            if(my $temp = $rm->find($in{map_id})) {
                $map = $temp->native;
            } else {
                $map = PureMessage::Map->new( $in{map_id} );
            }
            my @results = $map->transform( $val );
            $vars{map_results} = @results ? join('<br>', @results) : text('test_list_no_match');
        }
    }
};
if ($@) {
    $r->raise_error( $@ );
}

###############################################################################
# Show the page to the user.
###############################################################################
my $WIDGET   = new PureMessage::Manager::Widget;
    # Get info on all known lists.
my %known_lists = map { $_->{id} => $_->{name} } PureMessage::List->Available();
$vars{list_id_list} = $WIDGET->option_list(
                        'list_id', \%known_lists, $vars{list_id},
                        );
    # Get info on all known maps.
my %known_maps = map { $_->{id} => $_->{name} } PureMessage::Map->Available();
$vars{map_id_list} = $WIDGET->option_list(
                        'map_id', \%known_maps, $vars{map_id},
                        );
    # Set up our toolbar and wrapper box for our form.
my $toolbar = $WIDGET->widget(
                    CLASS   => 'PureMessage::Manager::Widget::ToolBar',
                    name    => 'tb',
                    buttons => [[
                                { type=>'image', name=>'test', text=>'Test', icon=>'continue' },
                               ]],
                    );
$vars{HEADER} = $r->ThemeSectionHeader( title => text('test_list_page_title') )->output();
$vars{FOOTER} = $r->ThemeSectionFooter( toolbar => $toolbar )->output();
    # Process the template
my $template = $WIDGET->widget(
                    CLASS   => 'PureMessage::Manager::Widget::Template',
                    filename=> 'test_list',
                    data    => \%vars,
                    );
$r->add_part( $template, 'body_form' );
    # Send everything to the browser.
$r->title( 'test_list_page_title' );
$r->send();
