package PureMessage::Policy::Logger;
use strict;
use base 'PureMessage::Logger';

sub new {
    my $class = shift;
    my %opts = @_;
    my $logger = delete($opts{logger}) || PureMessage::Logger->new(%opts);
    $opts{logger} = $logger;
    return bless \%opts, $class;
}

sub tee_stdout {
    my $self = shift;
    my $tee_stdout = shift;
    return $self->{tee_stdout} unless defined $tee_stdout;
    $self->{tee_stdout} = $tee_stdout;
}

sub log {
    my $self = shift;
    my $priority = shift;
        
    if ($self->{tee_stdout}) {
        if ($priority eq 'DEBUG' or
            $priority =~ /^\d/ and
            $priority == $self->SUPER::LOG_DEBUG) {
            if ($self->{debug}) {
                print @_;
                print "\n" unless $_[$#_] =~ /\n$/;
            }
        }
        else {
            print @_;
            print "\n" unless $_[$#_] =~ /\n$/;
            
        }
    }
    $self->{logger}->log($priority, @_);
}

1;
