package PureMessage::Policy::Repository;
use strict;
use PureMessage::Sieve qw(sieve_parse_file sieve_print sieve_text);
use PureMessage::Version qw($PREFIX);
use File::Basename qw(basename);
use PureMessage::Policy::Repository::Config qw(%policy_repository_config);
use PureMessage::Policy::Repository::File;
use Data::Dumper;
use ActiveState::File::Atomic;

=pod

=cut


=pod

=item Clipboard($filename)

Returns the clipboard as a PureMessage::Policy::Repository::File

=cut

our $_CLIPBOARD;

sub Clipboard {
  my ($CLASS,%options) = @_;
  if ($options{create} and ! -e clipboard_location()) {
    return $_CLIPBOARD = PureMessage::Policy::Repository::File->Create(clipboard_location());
  } else {
    return $_CLIPBOARD = PureMessage::Policy::Repository::File->Load(clipboard_location());
  }
}

our $_EDIT;

sub Edit {
  my ($CLASS,%options) = @_;
  if ($options{create} and ! -e edit_location()) {
    return $_EDIT = PureMessage::Policy::Repository::File->Create(edit_location());
  } else {
    return $_EDIT = PureMessage::Policy::Repository::File->Load(edit_location());
  }
}

sub edit_location {
  return "$PREFIX/etc/policy.siv.edit";
}

=item clipboard_location

Returns the filename of the clipboard file that the manager users to
implement the cut/paste feature of the sieve editor.

=cut

sub clipboard_location {
  return "$PREFIX/etc/.clipboard.siv";
}


=item Available

Returns an array of all the files found in the repository as 
PureMessage::Policy::Repository::Files.

=cut

sub Available {
  my @files = glob("$policy_repository_config{dir}/*.siv"); 
  my @result;
  @files = sort @files;
  foreach my $file (@files) {
    my $name = basename($file);
    push(@result,PureMessage::Policy::Repository::File->Load($name));
  }
  return @result;
}


1;


