package PureMessage::Policy::TestStore;
use strict;
use base 'PureMessage::MessageStore';
use PureMessage::Config qw(%config expand_filename);

sub new {
    my ($class, %opts) = @_;
    my $dir = delete $opts{dir} || expand_filename("var/policy/test_store");
    my $dir_type = delete $opts{dir_type} || "dir";

    $opts{logger} ||= do {
       require PureMessage::Logger;
       PureMessage::Logger->new(ident => "policy-test-store");
    };

    return $class->SUPER::new("$dir_type:$dir", %opts);
}
1;
